import javax.imageio.ImageIO;
import javax.swing.*;
import java.awt.*;
import java.io.File;
import java.io.IOException;

public class PersonRightPanel extends JPanel {
    private JLabel rightLabel = new JLabel();
    private String contentText = new String();
    private Image personImage;

    PersonRightPanel() {
        rightLabel.setText("Closest person found");
        add(rightLabel);
        try {
            this.personImage = ImageIO.read(new File("data/personImage.png"));
        } catch (IOException e) {
            System.out.println(e.getStackTrace());
        }
    }

    public void setContentText(String contentText) {
        this.contentText = contentText;
    }

    public String getContentText() {
        return contentText;
    }

    //FIXME: redraw on resizing
    /*@Override
    public void paint(Graphics g) {
        super.paint(g);
        drawPerson();
    }*/

    public void drawPerson(Person personObj) {
        Graphics g = this.getGraphics();
        g.clearRect(0, 25, getWidth(), getHeight());

        // Draw
        g.drawString(getContentText(), 12, 35);
        Graphics2D g2d = (Graphics2D) g;
        int imageWidth = 120;
        int imageHeight = 180;
        g2d.drawImage(this.personImage.getScaledInstance(imageWidth / 2, imageHeight / 2, Image.SCALE_SMOOTH), imageWidth / 4, imageHeight / 4, this);
        g2d.setColor(personObj.getEye().getColor());
        g2d.fillOval(50, 50, 6, 3);
        g2d.fillOval(62, 50, 6, 3);
    }
}
